/********************************************************************/
/*																	*/
/*	NVM_BOOT.C														*/
/*																	*/
/********************************************************************/

#include <stdio.h>
#include <tos.h>

#define NVMaccess(op, start, count, buffer)	xbios(46, op, start, count, buffer)

main ()
{
	int ret;
	char buffer;

	puts("\033pNVM 'wait for harddisk' & memory check modifier ");
	puts("written in Pure-C by Marco De Luca - Switzerland\033q\n");

	puts("Setzt im 'non volatile memory' von TT und Falcon");
	puts("das (undokumentierte) Byte 10 von ASCII 32 auf");
	puts("ASCII 0. Dadurch wird beim Booten auf den Memory-");
	puts("test und das 'Warten auf Harddisk' verzichtet");
	puts("(siehe ST-Computer 12/93, Quick-Tip Seite 152 -");
	puts("dort ist ein Pascal-Listing angegeben, hier das");
	puts("ganze in C).\n");
	puts("Das Programm arbeitet als Toggle, das heisst,");
	puts("nochmaliges Starten des Programms setzt den Wert");
	puts("wieder auf ASCII 32, usw.\n");

	ret = NVMaccess (0, 10, 1, &buffer);
	if (ret != 0)
	{
		printf("Fehler %d beim NVM auslesen!", ret);
		getchar();
		return 1;
	}

	if (buffer == 0)
	{
		buffer = 32;
		puts("\033pWarten auf Harddisk & Memory Test EINgeschaltet\033q");
	}
	else
	{
		buffer = 0;
		puts("\033pWarten auf Harddisk & Memory Test AUSgeschaltet\033q");
	}

	ret = NVMaccess (1, 10, 1, &buffer);
	if (ret == 0)
		puts("NVM erfolgreich gendert!");
	else
		printf("Fehler %d bei NVM zurckschreiben!", ret);

	puts("\n-Taste-");
	getchar();
	return 0;
}
